Attribute VB_Name = "shopify"
Option Explicit

Sub shopifyPayouts()

Dim lr As Long
lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
Dim vr As Long
vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count
Dim lc As Long
lc = Cells(1, Columns.Count).End(xlToLeft).Column
Dim topRow() As Integer
Dim col As Integer

    'SPLIT TO COLUMNS
    
    Dim comOrSc As Range
    Set comOrSc = Range("A1").Find(",")
    If comOrSc Is Nothing Then
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Semicolon:=True, TrailingMinusNumbers:=True
    Else
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Comma:=True, TrailingMinusNumbers:=True
    End If


    'DELETE "PENDING " AND "IN TRANSIT"
    'Check for existence of pendiong and in transit transactions
    Dim counter As Long
    counter = 0
    Dim i As Long
    For i = lr To 2 Step -1
        If Range("F" & i) = "in_transit" Or Range("F" & i) = "pending" Then
        Rows(i).EntireRow.Delete
        End If
    Next i
    lr = Range("A" & Rows.Count).End(xlUp).Row
    'Cells(2, 3).Select
    
    Dim amountCell As Range 'Amount (To be renamed as Betrag)
    Set amountCell = Rows(1).Find(what:="Amount", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim feeCell As Range 'Fee
    Set feeCell = Rows(1).Find(what:="Fee", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim netCell As Range 'Net
    Set netCell = Rows(1).Find(what:="Net", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim currencyCell As Range ' Used to insert a new column to the left of this
    Set currencyCell = Rows(1).Find(what:="Currency", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim payoutDateCell As Range ' Used to insert a new column to the left of this
    Set payoutDateCell = Rows(1).Find(what:="Payout Date", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim typeCell As Range ' Will be renamed "Auftragsart"
    Set typeCell = Rows(1).Find(what:="Type", LookIn:=xlValues, LookAt:=xlWhole)
    
    Dim checkoutCell As Range ' Will be renamed "Verwendungszweck"
    Set checkoutCell = Rows(1).Find(what:="Checkout", LookIn:=xlValues, LookAt:=xlWhole)
    
  
    'Convert columns Amount-Fee-Net from text to number format
    Dim ar As Variant
    Dim var As Variant
   

    '
    
    'Column I
    
    ar = Range(Cells(2, amountCell.Column), Cells(lr, amountCell.Column))
    ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * -1
    Next i
    Range(Cells(2, amountCell.Column), Cells(lr, amountCell.Column)) = var
    
    'Column J
    ar = Range(Cells(2, feeCell.Column), Cells(lr, feeCell.Column))
    'ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * 1
    Next i
    Range(Cells(2, feeCell.Column), Cells(lr, feeCell.Column)) = var
    
    'Column K
    ar = Range(Cells(2, netCell.Column), Cells(lr, netCell.Column))
    'ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * 1
    Next i
    Range(Cells(2, netCell.Column), Cells(lr, netCell.Column)) = var
    
    
    Columns(currencyCell.Column).EntireColumn.Insert
    
    Cells(1, currencyCell.Column - 1) = "Empfnger/Zahlungspflichtiger"
    Cells(1, currencyCell.Column - 1).Interior.ColorIndex = 37
    
    'Fill new Zahlungspflichtiger/Empfnger Column with "Shopify Auszahlung"
    For i = 2 To lr
        Cells(i, currencyCell.Column - 1) = "Shopify Auszahlung"
    Next i
       lc = Cells(1, Columns.Count).End(xlToLeft).Column
   Range(Cells(2, payoutDateCell.Column), Cells(lr, payoutDateCell.Column)).NumberFormat = "dd.mm.yyyy"
   Range(Cells(2, amountCell.Column), Cells(lr, amountCell.Column)).NumberFormat = "0.00"
   Range(Cells(2, amountCell.Column), Cells(lr, amountCell.Column)).Select
   Selection.Replace what:=",", replacement:="."
   'Range(Cells(2, amountCell.Column), Cells(lr, amountCell.Column)).HorizontalAlignment = xlRight
   
   Cells(1, payoutDateCell.Column) = "Buchungsdatum"
   Cells(1, payoutDateCell.Column).Interior.ColorIndex = 37
   
   Cells(1, currencyCell.Column) = "Whrung"
   Cells(1, currencyCell.Column).Interior.ColorIndex = 37
   
   Cells(1, checkoutCell.Column) = "Verwendungszweck"
   Cells(1, checkoutCell.Column).Interior.ColorIndex = 37
   
   Cells(1, typeCell.Column) = "Auftragsart"
   Cells(1, typeCell.Column).Interior.ColorIndex = 37
   
   Cells(1, amountCell.Column) = "Betrag"
   Cells(1, amountCell.Column).Interior.ColorIndex = 37
   
   
   'Delete Irrelevant columns
    Dim mc As Long
    mc = ActiveSheet.UsedRange.Columns.Count

    For i = mc To 1 Step -1
        If ActiveSheet.Cells(1, i).Interior.ColorIndex <> 37 Then
           ActiveSheet.Cells(1, i).EntireColumn.Delete
        End If
    Next i
   
    Dim x, y As Range
    Set x = Range(Cells(2, 4), Cells(lr, 4))
    
    'Wipe color on first row
    Range("A1:K1").Interior.ColorIndex = -4142
    
    'Eliminate "#" from Verwensdungszwek
    For Each y In x.Cells
        y = Replace(y, "#", "")
    Next y
    Range("D2 : D" & lr).NumberFormat = "0"
    
    
End Sub














